/*
 *   gr_dynmem.c
 *   gripho Vers. 0.4
 *                 Copyright (C)  2001  Matteo Nastasi
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *     CONTACT:    matteo.nastasi@milug.org
 *                 mnastasi@lycosmail.com
 *
 */

#include <stdlib.h>

#include "gripho.h"

void gr_free_chan(void ***pt, int y)
{
  int i;

  for (i = 0 ; i<y ; i++)
    if ((*pt)[i]) {
      free((*pt)[i]);  
      (*pt)[i] = NULL;
    }
}

void gr_free_data(void ****pt, int nchan, int y)
{
  int i;

  if (*pt) {
    for (i = 0 ; i<nchan ; i++)
      if ((*pt)[i]) 
	gr_free_chan(&(*pt)[i],y);
    free(*pt);
    *pt = NULL;
  }
}

int gr_alloc_chan(void ***pt, int size, int x, int y)
{
  int i;

  for (i = 0 ; i<y ; i++)
    (*pt)[i] = NULL;
  for (i = 0 ; i<y ; i++) {    
    if (((*pt)[i] = malloc(size * x)) == NULL)
      return FALSE;
  }
  return TRUE;
}

void ***gr_alloc_data(int nchan, int size, int x, int y)
{
  void ***pt;
  int i;

  /* alloca i chan pointer */
  if ((pt = (void ***)malloc(sizeof(void ***) * nchan)) == NULL)
    return NULL;
  /* azzera i row pointer */
  for (i = 0 ; i<nchan ; i++)
    pt[i] = NULL;
  /* alloca i row pointer */
  for (i = 0 ; i<nchan ; i++) {
    if ((pt[i] = (void **)malloc(sizeof(void **) * y)) == NULL) {
      gr_free_data(&pt,nchan,y);
      return NULL;
    }
  }
  for (i = 0 ; i<nchan ; i++) {
    if (!gr_alloc_chan(&(pt[i]),size,x,y)) {
      gr_free_data(&pt,nchan,y);
      return NULL;
    }
  }

  return pt;
}

