/*
 *   gr_layertool.c
 *   gripho Vers. 0.4
 *                 Copyright (C)  2001  Matteo Nastasi
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *     CONTACT:    matteo.nastasi@milug.org
 *                 mnastasi@lycosmail.com
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gripho.h"

void lay_fliporiz(gr_layer *ly)
{
  int nb,i,e,a;
  unsigned char cbf;
  nb = nbyte(ly->depth);

  if (nb == 1)
    for (i = 0 ; i < ly->y ; i++)
      for (e = 0 ; e < ly->x/2 ; e++)
	for (a = 0 ; a < ly->nchan ; a++) {
	  cbf = ((unsigned char *)ly->dt[a][i])[e];
	  ((unsigned char *)ly->dt[a][i])[e] = 
	    ((unsigned char *)ly->dt[a][i])[ly->x-e-1];
	  ((unsigned char *)ly->dt[a][i])[ly->x-e-1] = cbf;
	}
  else if (nb == 2) 
    for (i = 0 ; i < ly->y ; i++)
      for (e = 0 ; e < ly->x/2 ; e++)
	for (a = 0 ; a < ly->nchan ; a++) {
	  cbf = ((unsigned short *)ly->dt[a][i])[e];
	  ((unsigned short *)ly->dt[a][i])[e] = 
	    ((unsigned short *)ly->dt[a][i])[ly->x-e-1];
	  ((unsigned short *)ly->dt[a][i])[ly->x-e-1] = cbf;
	}
  else
    for (i = 0 ; i < ly->y ; i++)
      for (e = 0 ; e < ly->x/2 ; e++)
	for (a = 0 ; a < ly->nchan ; a++) {
	  cbf = ((unsigned long *)ly->dt[a][i])[e];
	  ((unsigned long *)ly->dt[a][i])[e] = 
	    ((unsigned long *)ly->dt[a][i])[ly->x-e-1];
	  ((unsigned long *)ly->dt[a][i])[ly->x-e-1] = cbf;
	}
}

void lay_flipvert(gr_layer *ly)
{
  int nb,i,e,a;
  unsigned char cbf;
  nb = nbyte(ly->depth);

  if (nb == 1)
    for (i = 0 ; i < ly->y/2 ; i++)
      for (e = 0 ; e < ly->x ; e++)
	for (a = 0 ; a < ly->nchan ; a++) {
	  cbf = ((unsigned char *)ly->dt[a][i])[e];
	  ((unsigned char *)ly->dt[a][i])[e] = 
	    ((unsigned char *)ly->dt[a][ly->y-i-1])[e];
	  ((unsigned char *)ly->dt[a][ly->y-i-1])[e] = cbf;
	}
  else if (nb == 2) 
    for (i = 0 ; i < ly->y/2 ; i++)
      for (e = 0 ; e < ly->x ; e++)
	for (a = 0 ; a < ly->nchan ; a++) {
	  cbf = ((unsigned short *)ly->dt[a][i])[e];
	  ((unsigned short *)ly->dt[a][i])[e] = 
	    ((unsigned short *)ly->dt[a][ly->y-i-1])[e];
	  ((unsigned short *)ly->dt[a][ly->y-i-1])[e] = cbf;
	}
  else
    for (i = 0 ; i < ly->y/2 ; i++)
      for (e = 0 ; e < ly->x ; e++)
	for (a = 0 ; a < ly->nchan ; a++) {
	  cbf = ((unsigned long *)ly->dt[a][i])[e];
	  ((unsigned long *)ly->dt[a][i])[e] = 
	    ((unsigned long *)ly->dt[a][ly->y-i-1])[e];
	  ((unsigned long *)ly->dt[a][ly->y-i-1])[e] = cbf;
	}
}
