/*
 *   maintest1.c
 *   gripho Vers. 0.4
 *                 Copyright (C)  2001  Matteo Nastasi
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *     CONTACT:    matteo.nastasi@milug.org
 *                 mnastasi@lycosmail.com
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "gripho.h"

int main()
{
  FILE *fp,*fpot;
  gripho *gr;
  gr_layer *ly,*ly2,*layer;
  int x,y,id,nb;

  fp = stdin;
  fpot = stdout;
  
  if ((gr = import_pnm(fp)) == NULL)
    printf("HA RESO NULL\n");
  /*
    printf("NON ha reso NULL\n");
    else
    */
  ly = gr->lays[0];
  
  /*  lay_fliporiz(ly);
      lay_flipvert(ly); */
  /*  gr->lays[0]->trans = GR_TRANS_OPAC / 2; */
  
  if (!img_addchan(gr,'A',GR_TRANS_OPAC))
    fprintf(stderr,"Alpha non aggiunto\n");

  if ((ly2 = lay_scalenew(ly,90,80)) == NULL)
    fprintf(stderr,"Layer non scalato\n");

  id = chan_getnumid(gr->schan,GR_C_ALPHA);
  nb = nbyte(gr->depth);
  
  for (x = 0 ; x < gr->x ; x++) 
    for (y = 0 ; y < gr->y ; y++) {
      chan_setpix(ly->dt[id][y],x,nb,(x * GR_TRANS_OPAC - 2) / gr->x);
    }
    
 
  /*  ly2->trans = GR_TRANS_OPAC / 2;  */
  if (!img_addlayer(gr,ly2,GR_LAYTYP_NORMAL,50,25))
    fprintf(stderr,"Layer non aggiunto\n");
  
  if ((layer = img_flatolay(gr,"rgb",8)) == NULL)    
    fprintf(stderr,"FALLITO FLATTING\n");

  explay_pnm(fpot,ly2);
  
  exit(0);
}
