/*
 *   mergepnm.c
 *   gripho Vers. 0.4
 *                 Copyright (C)  2001  Matteo Nastasi
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *     CONTACT:    matteo.nastasi@milug.org
 *                 mnastasi@lycosmail.com
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void usage (char *s,int ext) {
  printf("%s [-i|--invert] <fileimg> <filemsk> <fileout>\n",s);
  exit(ext);
}

int getdim(char *s,int *x,int *y)
{
  int i;

  for (i = 0 ; s[i] != '\0' ; i++) 
    if (s[i] == ' ' || s[i] == '\t')
      break;
  if (s[i] == '\0')
    return (0);
  s[i++] = '\0';
  *x = atoi(s);
  for (; s[i] != '\0' ; i++) 
    if (s[i] != ' ' && s[i] != '\t')
      break;
  if (s[i] == '\0')
    return (0);
  *y = atoi(&(s[i]));
  if (*x < 0 || *y < 0)
    return (0);

  return (1);
}
int main (int argc,char **argv)
{
  int i,e,c, invert = 0;
  int xim,yim,xms,yms,comp;
  FILE *fim,*fms,*fot;
  char bf[512];

  for (i = 1 ; i < argc ; i++) {
    if (argv[i][0] != '-')
      break;
    else if (!strcmp(argv[i],"-i") || !strcmp(argv[i],"--invert"))
      invert = 1;
    else
      usage(argv[0],1);
  }
  if (argc - i != 3)
    usage(argv[0],2);
  if ((fim = fopen(argv[i],"r")) == NULL)
    usage(argv[0],3);
  if ((fms = fopen(argv[i+1],"r")) == NULL)
    usage(argv[0],4);
  if ((fot = fopen(argv[i+2],"w")) == NULL)
    usage(argv[0],5);

  if (fgets(bf,512,fim) == NULL || strncmp(bf,"P6",2))
    exit(6);
  if (fgets(bf,512,fms) == NULL || strncmp(bf,"P5",2))
    exit(7);
  if (fgets(bf,512,fim) == NULL)
    exit(8);
  if (fgets(bf,512,fms) == NULL)
    exit(9);
  if (fgets(bf,512,fim) == NULL || !getdim(bf,&xim,&yim))
    exit(10);
  if (fgets(bf,512,fms) == NULL || !getdim(bf,&xms,&yms))
    exit(11);
  if (xim != xms || yim != yms)
    exit(12);
  if (fgets(bf,512,fim) == NULL || strncmp(bf,"255",3))
    exit(13);
  if (fgets(bf,512,fms) == NULL || strncmp(bf,"255",3))
    exit(14);
  for (e = 0 ; e < yim ; e++) {
    for (i = 0 ; i < xim ; i++) {
      for (c = 0 ; c < 3 ; c++) {
	if ((comp = fgetc(fim)) == EOF)
	  exit(15);
	fputc(comp,fot);
      }
      if ((comp = fgetc(fms)) == EOF)
	exit(16);
      if (invert)
	fputc(255-comp,fot);
      else
	fputc(comp,fot);
    }
  }
  fclose(fim);
  fclose(fms);
  fclose(fot);
  exit(0);
  return (0);
}
